# set this to point to the Cilk distribution directory.
CILK_DIR = /usr/local/src/lang/cilk
# CILK_DIR = /home/users/tabata/cilk/cilk

# set this to 1 to enable critical-path measurements
CILK_CRITICAL_PATH = 0

# include makefile from distribution directory
include $(CILK_DIR)/Makefile.common

LIBS	= -lm $(CILK_RTS) $(CILK_LIB) $(ARCHLIBS)
HEADERS = $(CILK_HEADERS)

all:	blockedmul cholesky cilksort ck fft fib game \
	heat knapsack knary lu magic notempmul queens spacemul testall

%.o:	%.c $(HEADERS) $(CILK_DIR)/Makefile.common
	$(CC) $(CFLAGS) -c $< -o $@

%.s:	%.c $(HEADERS) $(CILK_DIR)/Makefile.common
	$(CC) $(CFLAGS) -S $< -o $@

%.c:	%.cilk $(HEADERS) $(CILK2C) $(CILK_DIR)/Makefile.common
	$(CILK2C) $(CILK2CFLAGS) -- $(CFLAGS) -- $< -o $@ 

%:	%.o $(CILK_RTS) $(CILK_LIB)
	$(CC) $(LDFLAGS) $< $(LIBS) -o $@

clean:	
	$(RM) *.o core a.out *~ *.s *.bak 
