# assume environment variable ST_DIR is defined
# or defint it here
# ST_DIR = 

# SGC flags:
# assume environment variable SGC_DIR is defined
# or define it here
# SGC_DIR =
# uncomment following two lines if you use SGC (with stgcc).
SGC_FLAGS = -DWITH_SGC -I$(SGC_DIR)
SGC_LIB = --xsgc
# uncomment following two lines if you use SGC with plain gcc.
# SGC_FLAGS = -DWITH_SGC -I$(SGC_DIR)
# SGC_LIB = $(SGC_DIR)/sgc.a
# uncomment following two lines if you dont use SGC
# SGC_FLAGS = 
# SGC_LIB = 

# MTCAMP flags:
# uncomment following line if you use MTCAMP front end
MTCAMP_FLAGS = --xmtcamp -I/usr/local/include -I/usr/include

# define various vars SGC_FLAGS, SGC_LIB, L_THREAD_LIB, L_OS_LIB
include $(ST_DIR)/lib/sthreads.mk

%.o:%.cilk
	$(CC) $(CFLAGS) -x c -c $*.cilk
%.s:%.cilk
	$(CC) $(CFLAGS) -x c -S $*.cilk
%:  %.o
	$(CC) -o $* $*.o -L$(ST_DIR)/lib -lstext -lst -lm $(SGC_LIB) $(L_THREAD_LIB) $(L_OS_LIB)

# add C flags and C++ flags
CC_CXX_FLAGS = $(SGC_FLAGS) -O3 $(GC_OPTS) $(SGC_LIB) $(MTCAMP_FLAGS)
#-DST_DBG=0 -DST_ASSERT_ON=0 -DSTACK_INV_CHECK=0 -DST_STAT=0 -DST_PROF=0 -DUSE_SMALLOC 

CFLAGS = $(CC_CXX_FLAGS)
CXXFLAGS = $(CC_CXX_FLAGS)

# add basename of object files
BASES = *
OBJS = $(addsuffix .o,$(BASES))
ASMS = $(addsuffix .s,$(BASES))
TASMS = $(addsuffix .t,$(BASES))
PPS = $(addsuffix .t.pp,$(BASES))
TAB_CS = $(addsuffix .t.tab.c,$(BASES))
TAB_SS = $(addsuffix .t.tab.s,$(BASES))
TAB_S_PPS = $(addsuffix .t.tab.s.pp,$(BASES))

APP =	blockedmul cilksort fft fib \
	heat knapsack lu magic notempmul spacemul

all:	blockedmul cilksort fft fib \
	heat knapsack lu magic notempmul spacemul

clean : 
	rm -f core 
	rm -f $(OBJS) 
	rm -f $(ASMS) 
	rm -f $(TASMS) 
	rm -f $(TAB_CS) 
	rm -f $(TAB_SS) 
	rm -f $(TAB_S_PPS)
	rm -f $(PPS)

all_clean : clean
	rm -f $(APP)
	rm -f *~

