#ifdef USE_DEMOWIN

#include "gc_priv.h"
#include </home/all/endo/proj/python/Python-1.5.1/Include/Python.h>
#include <tcl.h>
#include <tk.h>

#define CANVAS_WIDTH 512
#define CANVAS_P_HEIGHT 512
#define CANVAS_L_HEIGHT 16384
#define CANVAS2_WIDTH 128

#define MAX_GCP 64

#define ROW_LINE 3
#define TOP_LINE 0
#define BOTTOM_LINE 3

struct demowin {
    PyObject *root;
    PyObject *roottk;
    PyObject *canvas;
    PyObject *canvas2;
    PyObject *scrollbar;
    PyObject *image;
    PyObject *imageid;
    PyObject *imageputmethod;

    PyObject *msrectids[MAX_GCP];
    int prevmsdatas[MAX_GCP];

    struct PhotoMaster * masterPtr;
    unsigned char *pix;
    unsigned char *curp;
    Tcl_Interp *interp;
    int screenstart;
    int screenend;
    int scrolled;
    int maxrow;

    int count;
    int count2;
    PSM_mutex_t mutex;
};

#define RECT_NCOLOR 16

struct my_color {
    unsigned char r;
    unsigned char g;
    unsigned char b;
};

struct my_color g_border_color = {0x80, 0x80, 0x80};
struct my_color g_empty_color = {0xff, 0xff, 0xff};

#define BORDER_COLOR g_border_color
#define EMPTY_COLOR g_empty_color

struct my_color rect_colors[RECT_NCOLOR] = {
    {0xff, 0x00, 0x00},
    {0x00, 0xff, 0x00},
    {0x00, 0x00, 0xff},

    {0xff, 0xff, 0x00},
    {0xff, 0x00, 0xff},
    {0x00, 0xff, 0xff},

    {0xff, 0x80, 0x80},
    {0x80, 0xff, 0x80},
    {0x80, 0x80, 0xff},

    {0xff, 0xff, 0x80},
    {0xff, 0x80, 0xff},
    {0x80, 0xff, 0xff},

    {0x80, 0x00, 0x00},
    {0x00, 0x80, 0x00},
    {0x00, 0x00, 0x80},

    {0x80, 0x80, 0x80},
};

/* callback from Tk. */
int GC_demowin_photo_entry(interp, clientData, argc, argv)
     Tcl_Interp * interp;
     ClientData clientData;
     int argc; char ** argv;
{
    GC_g_demowinp->masterPtr = (struct PhotoMaster *)clientData;

    {
	int W, H;
	unsigned char * pix24;
	
	Tk_GetPhotoInfo(GC_g_demowinp->masterPtr, &pix24, &W, &H);
	GC_g_demowinp->pix = pix24;
    }
    GC_g_demowinp->interp = interp;
    return TCL_OK;
}

void GC_demowin_get_scrollbar_status()
{
    {
	PyObject *rc;
	double s, e;
	int is, ie;
	rc = PyObject_CallMethod(GC_g_demowinp->scrollbar, "get", NULL);

	s = PyFloat_AsDouble(PyTuple_GetItem(rc, 0));
	e = PyFloat_AsDouble(PyTuple_GetItem(rc, 1));

	is = (int)(s * CANVAS_L_HEIGHT + 0.5);
	ie = (int)(e * CANVAS_L_HEIGHT + 0.5);
	if (is != GC_g_demowinp->screenstart ||
	    ie != GC_g_demowinp->screenend) {
	    GC_g_demowinp->scrolled = 1;
	    GC_g_demowinp->screenstart = is;
	    GC_g_demowinp->screenend = ie;
	}
    }
}

static char * update_cmd_args[] = { "update", 0 };

int GC_demowin_handle_some_events()
{
    PyObject *rc;
    int rc0;
    do {
	rc = PyObject_CallMethod(GC_g_demowinp->roottk, "dooneevent", "i",
				 TCL_DONT_WAIT);
	rc0 = PyInt_AsLong(rc);
    } while (rc0);
    return 0;
}

int GC_demowin_update_screen(int isall)
{
    int end;
    if (isall) {
	Tk_UpdatePhotoRegion(GC_g_demowinp->masterPtr,
			     0, GC_g_demowinp->screenstart,
			     CANVAS_WIDTH, GC_g_demowinp->screenend);
    }
    else {
	if (GC_g_demowinp->maxrow*ROW_LINE < GC_g_demowinp->screenend) {
	    end = GC_g_demowinp->maxrow*ROW_LINE;
	}
	else {
	    end = GC_g_demowinp->screenend;
	}
	Tk_UpdatePhotoRegion(GC_g_demowinp->masterPtr,
			     0, GC_g_demowinp->screenstart,
			     CANVAS_WIDTH, end);
    }
    Tk_UpdateCmd(0, GC_g_demowinp->interp, 1, update_cmd_args);
    return 0;
}

void GC_demowin_write_color(struct my_color color)
{
    struct my_color *p = (struct my_color *)GC_g_demowinp->curp;
    *p = color;
    p++;
    GC_g_demowinp->curp = (unsigned char *)p;
}

void GC_demowin_get_color_string(struct my_color c, char *str)
{
    sprintf(str, "#%02x%02x%02x", c.r, c.g, c.b);
}

void GC_demowin_empty_image(int isall)
{
    int ys, ye;
    
    if (isall) {
	ys = 0;
	ye = CANVAS_L_HEIGHT;
    }
    else {
	GC_demowin_get_scrollbar_status();
	ys = GC_g_demowinp->screenstart;
	ye = GC_g_demowinp->screenend;
    }
    {
	/* make a image of rectangles */
	int y;
	int x;
	int xlimit;
	
	xlimit = CANVAS_WIDTH;
	GC_g_demowinp->curp = GC_g_demowinp->pix +
	    ys*sizeof(struct my_color)*CANVAS_WIDTH;
	
	for (y = ys; y < ye; y++) {
	    for (x = 0; x < xlimit; x++) {
		GC_demowin_write_color(EMPTY_COLOR);
	    }
	}
    }
}

int GC_demowin_init()
{
    PyObject *mainmod;
    PyObject *dict;
    PyObject *v;
    PyObject *tkclass;
    PyObject *canvasclass;
    PyObject *photoimageclass;
    PyObject *scrollbarclass;
    PyObject *rc;

    char *dummyarg = "/home/users/endo/proj/p-gc/bh/SGC_demowin";

    GC_g_demowinp = (struct demowin *)
	GC_scratch_g_alloc(sizeof(struct demowin));

    /* initialize python */
    Py_Initialize();
    PySys_SetArgv(1, &dummyarg);
    mainmod = PyImport_AddModule("__main__");
    dict = PyModule_GetDict(mainmod);

    /* load Tkinter module */
    PyRun_String("from Tkinter import *", Py_file_input, dict, dict);

    /* Tk class constructor */
    tkclass = PyDict_GetItemString(dict, "Tk");
    /* Canvas class constructor */
    canvasclass = PyDict_GetItemString(dict, "Canvas");
    /* Scrollbar class constructor */
    scrollbarclass = PyDict_GetItemString(dict, "Scrollbar");
    /* Photo image constructor */
    photoimageclass = PyDict_GetItemString(dict, "PhotoImage");
   
    /* create root window object */
    GC_g_demowinp->root =
	PyObject_CallFunction(tkclass, NULL);
    /* create canvas object */
    GC_g_demowinp->canvas =
	PyObject_CallFunction(canvasclass,
			      "O{s:i,s:i,s:(iiii)}", GC_g_demowinp->root,
			      "width", CANVAS_WIDTH,
			      "height", CANVAS_P_HEIGHT,
			      "scrollregion", 0, 0,
			      CANVAS_WIDTH, CANVAS_L_HEIGHT);
    /* create 2nd canvas object */
    GC_g_demowinp->canvas2 =
	PyObject_CallFunction(canvasclass,
			      "O{s:i,s:i,s:(iiii)}", GC_g_demowinp->root,
			      "width", CANVAS2_WIDTH,
			      "height", CANVAS_P_HEIGHT);
    /* create scrollbar object */
    {
	PyObject *canvas_yview;
	PyObject *key_command;
	PyObject *scrollbar_set;
	PyObject *key_yscrollcommand;

	GC_g_demowinp->scrollbar =
	    PyObject_CallFunction(scrollbarclass,
				  "O{s:s}", GC_g_demowinp->root,
				  "orient", "vertical");
	key_command = PyString_FromString("command");
	canvas_yview =
	    PyObject_GetAttrString(GC_g_demowinp->canvas, "yview");
	PyObject_SetItem(GC_g_demowinp->scrollbar, key_command,
			 canvas_yview);

	key_yscrollcommand = PyString_FromString("yscrollcommand");
	scrollbar_set =
	    PyObject_GetAttrString(GC_g_demowinp->scrollbar, "set");
	PyObject_SetItem(GC_g_demowinp->canvas, key_yscrollcommand,
			 scrollbar_set);
    }

    /* pack */
    PyObject_CallMethod(GC_g_demowinp->canvas2, "pack",
			"{s:s}", "side", "left");
    PyObject_CallMethod(GC_g_demowinp->scrollbar, "pack",
			"{s:s,s:s}", "side", "right",
			"fill", "y");
    PyObject_CallMethod(GC_g_demowinp->canvas, "pack", NULL);

    GC_g_demowinp->image =
	PyObject_CallFunction(photoimageclass,
			      "s{s:i,s:i}",
			      "myimage",
			      "height", CANVAS_L_HEIGHT, 
			      "width", CANVAS_WIDTH);

    GC_g_demowinp->imageputmethod =
	PyObject_GetAttrString(GC_g_demowinp->image, "put");
    GC_g_demowinp->roottk =
	PyObject_GetAttrString(GC_g_demowinp->root, "tk");

    {
	PyObject *rc;
	Tk_RegisterPhotoProc("sgcdemo", GC_demowin_photo_entry);
	rc = PyObject_CallMethod(GC_g_demowinp->roottk, "call",
				 "sssiiiiiiiiiii",
				 "myimage",
				 "proc",
				 "sgcdemo",
				 0, 0, CANVAS_WIDTH, CANVAS_L_HEIGHT, 
				 1234, 1, 2, 3, 4, 100, 1);
    }

    GC_g_demowinp->scrolled = 0;
    GC_demowin_get_scrollbar_status();
    GC_demowin_empty_image(1);

    GC_g_demowinp->imageid =
	PyObject_CallMethod(GC_g_demowinp->canvas, "create_image",
			     "ii{s:O,s:s}",
			     0, 0, "image", GC_g_demowinp->image,
			     "anchor", "nw");

    PSM_mutex_init(&GC_g_demowinp->mutex);
    GC_demowin_handle_some_events();
    GC_demowin_update_screen(1);
    return 0;
}

int GC_demowin_end()
{
    PyObject_CallMethod(GC_g_demowinp->canvas, "delete",
			"O",
			GC_g_demowinp->imageid);

    PSM_mutex_destroy(&GC_g_demowinp->mutex);
    PyObject_CallMethod(GC_g_demowinp->root, "quit", NULL);
    GC_demowin_handle_some_events();
    Py_Finalize();
    return 0;
}

void GC_demowin_init_phase_hblk(struct hblk *h, int row)
{
    hdr * hhdr;
    int sz;
    word *p, *plim;
    int word_no;
    int xlimit;

    GET_HDR(h, hhdr);
    sz = hhdr->hb_sz;

    if (row*ROW_LINE >= GC_g_demowinp->screenstart &&
	row*ROW_LINE <= GC_g_demowinp->screenend) {
	/* make a image of rectangles */
	int y;
	int x;
	int rectw;
	char *str;
	
	xlimit = CANVAS_WIDTH;
	rectw = sz/2;
	if (rectw < 2) {
	    fprintf(stderr, "!");
	    rectw = 2;
	}

	GC_g_demowinp->curp = GC_g_demowinp->pix +
	    row*sizeof(struct my_color)*CANVAS_WIDTH*ROW_LINE;
	for (y = 0; y < ROW_LINE; y++) {
	    if (y == TOP_LINE || y == BOTTOM_LINE) {
		for (x = 0; x < xlimit; x++) {
		    GC_demowin_write_color(BORDER_COLOR);
		}
	    }
	    else if (y > BOTTOM_LINE) {
		for (x = 0; x < xlimit; x++) {
		    GC_demowin_write_color(EMPTY_COLOR);
		}
	    }
	    else {
		for (x = 0; x < xlimit; x++) {
		    if ((x % rectw) == 0) {
			GC_demowin_write_color(BORDER_COLOR);
		    }
		    else {
			GC_demowin_write_color(EMPTY_COLOR);
		    }
		}
	    }
	}
    }

    hhdr->dirty = 0;

    p = (word *)(h->hb_body);
    word_no = HDR_WORDS;
#if 0
    plim = (word *)((((word)h) + HBLKSIZE)
		   - WORDS_TO_BYTES(sz));
#else
    plim = (word *)((((word)h) + HBLKSIZE)
		   - 1);
#endif
    while (p <= plim) {
	hhdr->marker[word_no] = -1;
	word_no += sz;
	p += sz;
    }
}

int GC_demowin_init_phase()
{
    int row;
    int j;
    bottom_index * index_p;
    
    row = 0;

    GC_demowin_get_scrollbar_status();

    /* iterate all blocks */
    for (index_p = GC_all_bottom_indices; index_p != 0;
         index_p = index_p -> asc_link) {
        for (j = 0; j < BOTTOM_SZ; j++) {
            if (!IS_FORWARDING_ADDR_OR_NIL(index_p->index[j])) {
                if (index_p->index[j]->hb_map != GC_invalid_map) {
			GC_demowin_init_phase_hblk(((struct hblk *)
                  	      (((index_p->key << LOG_BOTTOM_SZ) + (word)j)
                  	       << LOG_HBLKSIZE)),
						   row);
		    row++;
                }
	    }
         }
	GC_demowin_handle_some_events();
    }

    GC_g_demowinp->maxrow = row;

#if 0
    GC_g_demowinp->imageid =
	PyObject_CallMethod(GC_g_demowinp->canvas, "create_image",
			     "ii{s:O,s:s}",
			     0, 0, "image", GC_g_demowinp->image,
			     "anchor", "nw");
#endif

    {
	int pno;
	int ngcp = GC_count_gcproc_envps();
	int pe_line = CANVAS_P_HEIGHT/ngcp;
	GC_thread envp;
	if (pe_line > 16) pe_line = 16;
	for (envp = GC_g_appproc_envps.head, pno = 0;
	     envp;
	     envp = envp->next, pno++) {
	    if (GC_l_initialized(envp) == 0) continue;
	    if (GC_l_terminated(envp) != 0) continue;
	    struct my_color c1;
	    char c2[16];
	    c1 = rect_colors[pno%RECT_NCOLOR];
	    GC_demowin_get_color_string(c1, c2);
	    GC_g_demowinp->msrectids[pno] =
		PyObject_CallMethod(GC_g_demowinp->canvas2,
				    "create_rectangle",
				    "iiii{s:s,s:s}",
				    0, pno*pe_line,
				    1, pno*pe_line + (int)(pe_line*0.8),
				    "fill", c2,
				    "outline", c2);
	    GC_g_demowinp->prevmsdatas[pno] = -1;
	}
    }

    GC_g_demowinp->count = 0;

    GC_demowin_handle_some_events();
    GC_demowin_update_screen(1);
}

void GC_demowin_end_phase()
{
    /* Show last image (disappears soon...) */
    GC_demowin_handle_some_events();
    GC_demowin_update_screen(1);

#if 0
    PyObject_CallMethod(GC_g_demowinp->canvas, "delete",
			"O",
			GC_g_demowinp->imageid);
#endif

    {
	int pno;
	GC_thread envp;
	for (envp = GC_g_appproc_envps.head, pno = 0;
	     envp;
	     envp = envp->next, pno++) {
	    PyObject_CallMethod(GC_g_demowinp->canvas2, "delete",
				"O",
				GC_g_demowinp->msrectids[pno]);
	}
    }

#if 0
    GC_demowin_empty_image(1);
#else
    GC_demowin_init_phase();
#endif
    GC_demowin_handle_some_events();
    GC_demowin_update_screen(0);
}

void GC_demowin_add_row(struct hblk *h, int row)
{
    hdr * hhdr;
    int sz;
    int word_no;

    int xlimit;

    GET_HDR(h, hhdr);
    sz = hhdr->hb_sz;

    GC_g_demowinp->curp = GC_g_demowinp->pix +
	row*sizeof(struct my_color)*CANVAS_WIDTH*ROW_LINE;
    {
	/* make a image of rectangles */
	int y;
	int x;
	int rectw;
	
	xlimit = CANVAS_WIDTH;
	rectw = sz/2;
	if (rectw < 2) {
	    fprintf(stderr, "!");
	    rectw = 2;
	}

	for (y = 0; y < ROW_LINE; y++) {
	    if (y == TOP_LINE || y == BOTTOM_LINE) {
		for (x = 0; x < xlimit; x++) {
		    GC_demowin_write_color(BORDER_COLOR);
		}
	    }
	    else if (y > BOTTOM_LINE) {
		for (x = 0; x < xlimit; x++) {
		    GC_demowin_write_color(EMPTY_COLOR);
		}
	    }
	    else {
		struct my_color color = EMPTY_COLOR;
		word_no = HDR_WORDS;
		for (x = 0; x < xlimit; x++) {
		    if ((x % rectw) == 0) {
			GC_demowin_write_color(BORDER_COLOR);

			if (hhdr->marker[word_no] >= 0) {
			    color = rect_colors[hhdr->marker[word_no] %
					       RECT_NCOLOR];
			}
			else {
			    color = EMPTY_COLOR;
			}
			word_no += sz;
		    }
		    else {
			GC_demowin_write_color(color);
		    }
		}
	    }
	}
    }
}

void GC_demowin_rewrite(SGC_MYENV_ARG0)
SGC_MYENV_ARG_DECL2
{
    int row;
    int j;
    bottom_index * index_p;
    int drawn;
    int caching;
    
    row = 0;
    drawn = 0;

#if 0
    PyObject_CallMethod(GC_g_demowinp->canvas, "delete",
			"O",
			GC_g_demowinp->imageid);
#endif
    GC_demowin_get_scrollbar_status();

    /* iterate all blocks */
    for (index_p = GC_all_bottom_indices; index_p != 0;
         index_p = index_p -> asc_link) {
        for (j = 0; j < BOTTOM_SZ; j++) {
	    hdr * hhdr = index_p->index[j];
	    struct hblk * h;
            if (!IS_FORWARDING_ADDR_OR_NIL(hhdr)) {
                if (hhdr->hb_map != GC_invalid_map) {
		    /* */
		    h = ((struct hblk *)
			 (((index_p->key << LOG_BOTTOM_SZ) + (word)j)
			  << LOG_HBLKSIZE));
		    if (row*ROW_LINE >= GC_g_demowinp->screenstart &&
			row*ROW_LINE <= GC_g_demowinp->screenend) {
			if (hhdr->dirty || GC_g_demowinp->scrolled) {
			    GC_demowin_add_row(h, row);
			    hhdr->dirty = 0;
			    drawn++;
			}
		    }
		    row++;
                }
	    }
         }
	if (GC_g_demowinp->scrolled) {
	    GC_demowin_update_screen(1);
	}
	GC_demowin_handle_some_events();
     }

#if 0
    GC_g_demowinp->imageid =
	PyObject_CallMethod(GC_g_demowinp->canvas, "create_image",
			     "ii{s:O,s:s}",
			     0, 0, "image", GC_g_demowinp->image,
			     "anchor", "nw");
#endif

    if (GC_g_demowinp->scrolled) {
	GC_g_demowinp->scrolled = 0;
	GC_demowin_update_screen(1);
    }
    else {
	GC_demowin_update_screen(0);
    }
    GC_demowin_handle_some_events();
}

GC_demowin_mb_update(word *obj, hdr *hhdr)
{
    DECLARE_MYENV
    int displ;

    displ = BYTES_TO_WORDS(HBLKDISPL(obj));

    hhdr->marker[displ] = GC_myg_pno;
    hhdr->dirty = 1;

    PSM_mutex_lock(&GC_g_demowinp->mutex);
    GC_g_demowinp->count++;
    if (GC_g_demowinp->count > 100) {
	/* scan heap */
	GC_demowin_rewrite(SGC_MYENV_ARG0);

	GC_g_demowinp->count = 0;
    }
    PSM_mutex_unlock(&GC_g_demowinp->mutex);
}

GC_demowin_ms_update()
{
    DECLARE_MYENV
    struct my_color c1;
    char c2[16];
    int pno = GC_myg_pno;
    int nmse;
#if DO_LOADDIST == 3
    int smq_size = GC_myg_smq.size;
    mse *smq_in = (mse *)GC_myg_smq.in;
    mse *smq_out = (mse *)GC_myg_smq.out;
#endif
    
    /* calculate task amout */
    nmse = GC_my_mark_stack.top - GC_my_mark_stack.bottom;
#if DO_LOADDIST == 3
    nmse += (smq_in >= smq_out)? (smq_in-smq_out): (smq_in+smq_size-smq_out);
#endif

    if (nmse != GC_g_demowinp->prevmsdatas[pno]) {
	GC_g_demowinp->prevmsdatas[pno] = nmse;

	c1 = rect_colors[pno%RECT_NCOLOR];
	GC_demowin_get_color_string(c1, c2);

	PSM_mutex_lock(&GC_g_demowinp->mutex);

	/* delete old rect */
	PyObject_CallMethod(GC_g_demowinp->canvas2, "delete",
			    "O",
			    GC_g_demowinp->msrectids[pno]);
	
	/* create new rect */
	{
	    int ngcp = GC_count_gcproc_envps();
	    int pe_line = CANVAS_P_HEIGHT/ngcp;
	    if (pe_line > 16) pe_line = 16;
	    
	    GC_g_demowinp->msrectids[pno] =
		PyObject_CallMethod(GC_g_demowinp->canvas2,
				    "create_rectangle",
				    "iiii{s:s,s:s}",
				    0, pno*pe_line,
				    nmse, pno*pe_line + (int)(pe_line*0.8),
				    "fill", c2,
				    "outline", c2);
	}
	
	GC_g_demowinp->count2++;
	if (GC_g_demowinp->count2 > 100) {
	    /* scan heap */
	    Tk_UpdateCmd(0, GC_g_demowinp->interp, 1, update_cmd_args);
	    
	    GC_g_demowinp->count2 = 0;
	}
	PSM_mutex_unlock(&GC_g_demowinp->mutex);
    }

}

/* dummy */
void Tcl_Free(char *p)
{
    printf("!!!!!\n");
}

char *Tcl_Alloc(unsigned int s)
{
    printf("!!!!!\n");
}

#endif /* USE_DEMOWIN */
