/* This file contains old functions. */

/*******************************************************************/
/* Very simple Msg/RPC utility. Used by GC processes. */
/*******************************************************************/
/* Called by one GC process or App process. */
static int GC_sh_send_to(procno)
  int procno;
{
    GC_l_rpc(procno).send = 1;
    GC_sh_sync();
    return 0;
}

/*******************************************************************/
/* Called by any GC process. */
static int GC_sh_receive()
{
    SH_USE_MYENV;
    word volatile *chp;

    chp = &GC_my_rpc.send;
    while (*chp == 0) {
    }
    *chp = 0;
    GC_sh_sync();
    return 0;
}

/*******************************************************************/
/* Called by any GC process. */
static int GC_sh_send_ack()
{
    SH_USE_MYENV;
    GC_my_rpc.recv = 1;
    GC_sh_sync();
    return 0;
}

/*******************************************************************/
/* Called by one GC process or App process. */
static int GC_sh_receive_ack_from(procno)
  int procno;
{
    volatile word *chp;

    chp = &GC_l_rpc(procno).recv;
    while (*chp == 0) {
    }
    *chp = 0;
    GC_sh_sync();
    return 0;
}

/*******************************************************************/
/*******************************************************************/
int GC_sh_scheduler()
{
    SH_USE_MYENV;
    ptr_t (*func)();
    ptr_t arg1;
    ptr_t arg2;
    ptr_t arg3;
    ptr_t result;

    while (1) {
	GC_sh_receive();

	func = GC_my_rpc.func;
	arg1 = GC_my_rpc.arg1;
	arg2 = GC_my_rpc.arg2;
	arg3 = GC_my_rpc.arg3;

	if (func == NULL) {
	    /* Null function means `Quit Scheduler'. */
#if 0
	    fprintf(stderr, "Process %d received Quit Scheduler message.\n", GC_my_pno);
#endif
	    GC_sh_send_ack();
	    break;
	}
	
#if 0
	fprintf(stderr, "Process %d execute function %08x.\n", GC_my_pno, func);
#endif
	result = (*func)(arg1, arg2, arg3);
	GC_my_rpc.result = result;
#if 0
	fprintf(stderr, "Process %d send ACK.\n", GC_my_pno);
#endif
	GC_sh_send_ack();
    }
    return 0;
}

/*******************************************************************/
int GC_sh_future(procno, func, arg1, arg2, arg3)
  int procno;
  ptr_t (*func)();
  ptr_t arg1;
  ptr_t arg2;
  ptr_t arg3;
{
    GC_l_rpc(procno).func = func;
    GC_l_rpc(procno).arg1 = arg1;
    GC_l_rpc(procno).arg2 = arg2;
    GC_l_rpc(procno).arg3 = arg3;
    GC_sh_send_to(procno);
#if 0
    fprintf(stderr, "Request RPC %d -> %d (func %08x)\n", GC_my_pno, procno, func);
#endif
    return 0;
}

/*******************************************************************/
ptr_t GC_sh_invoke_remote(procno, func, arg1, arg2, arg3)
  int procno;
  ptr_t (*func)();
  ptr_t arg1;
  ptr_t arg2;
  ptr_t arg3;
{
    SH_USE_MYENV;
    ptr_t result;

#ifdef SGC_SPMD
    if (procno == GC_my_pno) {
	result = (*func)(arg1, arg2, arg3);
    }
    else {
	GC_sh_future(procno, func, arg1, arg2, arg3);
	GC_sh_receive_ack_from(procno);
#if 0
	fprintf(stderr, "Received ACK %d <- %d\n", GC_my_pno, procno);
#endif
	result = GC_l_rpc(procno).result;
    }
#else /* SGC_SPMD */
    GC_sh_future(procno, func, arg1, arg2, arg3);
    GC_sh_receive_ack_from(procno);
#if 0
    fprintf(stderr, "Received ACK from GCproc %d\n", procno);
#endif
    result = GC_l_rpc(procno).result;
#endif /* SGC_SPMD */
    return result;
}

/*******************************************************************/
int GC_sh_doall(func, arg1, arg2, arg3)
  ptr_t (*func)();
  ptr_t arg1;
  ptr_t arg2;
  ptr_t arg3;
{
    SH_USE_MYENV;
    int procno;

#ifdef SGC_SPMD
    for (procno = 0; procno < GC_n_gc_procs; procno++) {
	if (!IS_VALID_PNO(procno)) continue;
	/* Skip self */
	if (procno == GC_my_pno) continue;
	GC_sh_future(procno, func,
		     arg1, arg2, arg3);
    }
    /* Self work */
    (*func)(arg1, arg2, arg3);

    for (procno = 0; procno < GC_n_gc_procs; procno++) {
	if (!IS_VALID_PNO(procno)) continue;
	/* Skip self */
	if (procno == GC_my_pno) continue;
	GC_sh_receive_ack_from(procno);
    }
#else /* SGC_SPMD */
    /* TODO: */
#endif /* SGC_SPMD */

    return 0;
}

/*******************************************************************/
/* This function must be called by GC process. */
/* We assume the world is stopped. */
int GC_sh_stopped_mark_main()
{
    SH_USE_MYENV;
    int procno;
    struct timeval rst;
    struct timeval ret;

# if DO_LOAD_DIST == 3 || DO_LOAD_DIST == 4
    GC_sh_ld_init_phase();
# endif

    GC_MARKLOG_INIT_PHASE();

    GC_sh_doall(GC_sh_before_marksweep_local, 
		NULL, NULL, NULL);

    fflush(stdout);
    fflush(stderr);
    /* usleep(50*1000); */

    GC_arrays_p->debug_gcing = 1;
    GC_LDLOG_INIT_PHASE();
    GC_BMLOG_INIT_PHASE();
    GC_X2LOG_INIT_PHASE();
    GC_CSLOG_INIT_PHASE();
    GC_MARKLOG_START_CLOCK();

    GC_sh_doall(GC_sh_stopped_mark_local, NULL, NULL, NULL);

    GC_mark_state = MS_NONE;

    GC_MARKLOG_STOP_CLOCK();
    GC_CSLOG_END_PHASE();
    GC_X2LOG_END_PHASE();
    GC_BMLOG_END_PHASE();
    GC_LDLOG_END_PHASE();
#if 1
    GC_sh_doall(GC_sh_after_marksweep_local, NULL, NULL, NULL);
#endif

    return 0;
}

/* This function must be called by one process. */
/* Stop all processes except caller. */
/*******************************************************************/
ptr_t GC_sh_stop_world()
{
    SH_USE_MYENV;
    int procno;
    struct timeval st;
    struct timeval et;
    int d;

#ifdef DO_GCRLOG
    gettimeofday(&st, NULL);
#endif

#if 1
    fprintf(stderr, "pno %d send signal to others..\n",
	    GC_my_pno);
    fflush(stderr);
#endif
    for (procno = 0; procno < SGC_MAX_APP_PROCESS; procno++) {
	if (!IS_VALID_APPPNO(procno)) continue;
	/* Skip self */
	if (procno == GC_my_pno) continue;

	GC_my_envp->rpc_send = 0;
	GC_my_envp->rpc_recv = 0;
#if defined SHAREDGC_P
	kill(GC_sh_lenv_p(procno)->pid, SIGUSR2);
#elif SHAREDGC_ST
	thr_kill(GC_sh_lenv_p(procno)->pid, SIGUSR2);
#elif SHAREDGC_PT
	pthread_kill(GC_sh_lenv_p(procno)->pid, SIGUSR2);
#endif
    }

#if 0
    fprintf(stderr, "pno %d wait ack from others..\n",
	    GC_my_pno);
    fflush(stderr);
#endif

    for (procno = 0; procno < SGC_MAX_APP_PROCESS; procno++) {
	if (!IS_VALID_APPPNO(procno)) continue;
	/* Skip self */
	if (procno == GC_my_pno) continue;

	GC_sh_receive_ack_from(procno);
    }

#ifdef DO_GCRLOG
    gettimeofday(&et, NULL);
    {
	fprintf(stderr, "[stop_world]it took %d us to stop-world.\n", SHZZZ_CALCDIFFTIME(st, et));
    }
#endif

    return NULL;
}

/* This function must be called by one process. */
/* Awake all processes except caller. */
/*******************************************************************/
ptr_t GC_sh_start_world()
{
    SH_USE_MYENV;
    int procno;

    for (procno = 0; procno < SH_MAX_USERPROCESS; procno++) {
	if (GC_sh_lenv_p(procno) == NULL) continue;
	/* Skip self */
	if (procno == GC_my_pno) continue;

	GC_sh_future(procno, NULL, NULL, NULL, NULL); /* awake */
    }
    for (procno = 0; procno < SH_MAX_USERPROCESS; procno++) {
	if (GC_sh_lenv_p(procno) == NULL) continue;
	/* Skip self */
	if (procno == GC_my_pno) continue;

	GC_sh_receive_ack_from(procno);
    }
    return NULL;
}

/*******************************************************************/
/* This function must be called by GC process. */
/* We assume the world is stopped. */
int GC_sh_reclaim_main()
{
#if GC_SH_MEASURE_RECLAIM > 0
    int to_redo;
#endif    

#if GC_SH_MEASURE_RECLAIM > 0
    to_redo = (GC_sh_paint_markbits())? 10: 0;
 REDO:
#endif

    GC_LDLOG_INIT_PHASE();
    GC_MARKLOG_START_CLOCK();

    GC_sh_hbiter_start();
    GC_sh_doall(GC_sh_clear_lists_local, NULL, NULL, NULL);
    GC_sh_doall(GC_sh_reclaim_local, NULL, NULL, NULL);
    GC_sh_make_hblkfl();
    GC_sh_hbiter_end();

    GC_MARKLOG_STOP_CLOCK();
    GC_LDLOG_END_PHASE();

#if 0
    GC_sh_doall(GC_sh_after_marksweep_local, NULL, NULL, NULL);
#endif
    GC_MARKLOG_END_PHASE();

#if GC_SH_MEASURE_RECLAIM > 0
    if (to_redo) {
	if (to_redo == 1) {
	    GC_sh_rollback_markbits();
	}
	to_redo --;
	goto REDO;
    }
#endif

    return 0;
}


/******************************************** from alloc.c */

/* 
 * Initiate a garbage collection if appropriate.
 * Choose judiciously
 * between partial, full, and stop-world collections.
 * Assumes lock held, signals disabled.
 */
void GC_maybe_gc()
{
    static int n_partial_gcs = 0;
    if (GC_should_collect()) {
        if (!GC_incremental) {
            GC_gcollect_inner();
            n_partial_gcs = 0;
        } else if (n_partial_gcs >= GC_full_freq) {
            GC_initiate_full();
            n_partial_gcs = 0;
        } else {
            /* We try to mark with the world stopped.	*/
            /* If we run out of time, this turns into	*/
            /* incremental marking.			*/
            GET_TIME(GC_start_time);
            if (GC_stopped_mark(GC_timeout_stop_func)) {
#               ifdef SAVE_CALL_CHAIN
                  GC_save_callers(GC_last_stack);
#               endif
                GC_finish_collection();
            }
            n_partial_gcs++;
        }
    }
}

/*
 * Stop the world garbage collection.  Assumes lock held, signals disabled.
 * If stop_func is not GC_never_stop_func, then abort if stop_func returns TRUE.
 */
bool GC_try_to_collect_inner(stop_func)
GC_stop_func stop_func;
{
#ifdef SHAREDGC /* Added by Endo */
    GC_sh_sumup_counters();
#endif

    GC_sh_lock_all_flrl();
GC_sh_dump_list_stat();
#ifdef DO_GCRLOG
    GC_gcrlog_init_gc();
#endif

#   ifdef PRINTSTATS
	GC_printf2(
	   "Initiating full world-stop collection %lu after %ld allocd bytes\n",
	   (unsigned long) GC_gc_no+1,
	   (long)WORDS_TO_BYTES(GC_sum_app_stat.words_allocd));
#   endif
    GC_promote_black_lists();
    /* Make sure all blocks have been reclaimed, so sweep routines	*/
    /* don't see cleared mark bits.					*/
    /* If we're guaranteed to finish, then this is unnecessary.		*/
	if (stop_func != GC_never_stop_func && !GC_reclaim_all(stop_func)) {
	    /* Aborted.  So far everything is still consistent.	*/
	    return(FALSE);
	}
    GC_invalidate_mark_state();  /* Flush mark stack.	*/
    GC_clear_marks();
#   ifdef SAVE_CALL_CHAIN
        GC_save_callers(GC_last_stack);
#   endif
    if (!GC_stopped_mark(stop_func)) {
    	/* We're partially done and have no way to complete or use 	*/
    	/* current work.  Reestablish invariants as cheaply as		*/
    	/* possible.							*/
    	GC_invalidate_mark_state();
	GC_unpromote_black_lists();
    	if (GC_incremental) {
    	    /* Unlikely.  But just invalidating mark state could be	*/
    	    /* expensive.						*/
    	    GC_clear_marks();
    	}
    	return(FALSE);
    }
    GC_finish_collection();
#ifdef DO_GCRLOG
    GC_gcrlog_end_gc();
#endif
GC_sh_dump_list_stat();
    GC_sh_unlock_all_flrl();
    return(TRUE);
}

void GC_collect_a_little_inner(n)
int n;
{
    register int i;
    
    if (GC_collection_in_progress()) {
    	for (i = GC_deficit; i < GC_RATE*n; i++) {
    	    if (GC_mark_some()) {
    	        /* Need to finish a collection */
#     		ifdef SAVE_CALL_CHAIN
        	    GC_save_callers(GC_last_stack);
#     		endif
		(void) GC_stopped_mark(GC_never_stop_func);
    	        GC_finish_collection();
    	        break;
    	    }
    	}
    	if (GC_deficit > 0) GC_deficit -= GC_RATE*n;
    } else {
        GC_maybe_gc();
    }
}

int GC_collect_a_little GC_PROTO(())
{
    int result;
    DCL_LOCK_STATE;

    DISABLE_SIGNALS();
    LOCK();
    GC_collect_a_little_inner(1);
    result = (int)GC_collection_in_progress();
    UNLOCK();
    ENABLE_SIGNALS();
    return(result);
}

/*
 * Assumes lock is held, signals are disabled.
 * We stop the world.
 * If final is TRUE, then we finish the collection, no matter how long
 * it takes.
 * Otherwise we may fail and return FALSE if this takes too long.
 * Increment GC_gc_no if we succeed.
 */
bool GC_stopped_mark(stop_func)
GC_stop_func stop_func;
{
    register int i;
#   ifdef PRINTSTATS
	CLOCK_TYPE start_time, current_time;
#   endif
	
    STOP_WORLD();
#   ifdef PRINTSTATS
	GET_TIME(start_time);
	GC_printf1("--> Marking for collection %lu ",
	           (unsigned long) GC_gc_no + 1);
	GC_printf2("after %lu allocd bytes + %lu wasted bytes\n",
	   	   (unsigned long)WORDS_TO_BYTES(GC_sum_app_stat.words_allocd),
	   	   (unsigned long)WORDS_TO_BYTES(GC_sum_app_stat.words_wasted));
#   endif

    /* Mark from all roots.  */
    GC_sh_stop_world();
    GC_sh_stopped_mark_main();
	
    GC_gc_no++;
#   ifdef PRINTSTATS
#ifdef SHAREDGC
    GC_sh_add_mem_found();
#endif
      GC_printf2("Collection %lu reclaimed %ld bytes",
		  (unsigned long) GC_gc_no - 1,
	   	  (long)WORDS_TO_BYTES(GC_sum_gc_stat.mem_found));
      GC_printf1(" ---> heapsize = %lu bytes\n",
      	        (unsigned long) GC_heapsize);
      /* Printf arguments may be pushed in funny places.  Clear the	*/
      /* space.								*/
      GC_printf0("");
#   endif      

    /* Check all debugged objects for consistency */
        if (GC_debugging_started) {
            (*GC_check_heap)();
        }
    
#   ifdef PRINTTIMES
	GET_TIME(current_time);
	GC_printf1("World-stopped marking took %lu msecs\n",
	           MS_TIME_DIFF(current_time,start_time));
#   endif
    START_WORLD();
    return(TRUE);
}


/* Finish up a collection.  Assumes lock is held, signals are disabled,	*/
/* but the world is otherwise running.					*/
void GC_finish_collection()
{
#   ifdef PRINTTIMES
	CLOCK_TYPE start_time;
	CLOCK_TYPE finalize_time;
	CLOCK_TYPE done_time;
	
	GET_TIME(start_time);
	finalize_time = start_time;
#   endif

#   ifdef GATHERSTATS
#ifdef SHAREDGC /* Added by Endo */
	{
	    int procno;
	    gcproc_stat_t *l_statp;

	    for (procno = 0; procno < GC_arrays_p->n_gc_procs; procno++) {
		l_statp = &GC_l_gcenvp(procno)->stat;
		l_statp->mem_found = 0;
	    }
	}
#endif
	GC_sum_gc_stat.mem_found = 0;
#   endif
#   ifdef FIND_LEAK
      /* Mark all objects on the free list.  All objects should be */
      /* marked when we're done.				   */
	{
	  register word size;		/* current object size		*/
	  register ptr_t p;	/* pointer to current object	*/
	  register struct hblk * h;	/* pointer to block containing *p */
	  register hdr * hhdr;
	  register int word_no;           /* "index" of *p in *q          */
	  int kind;

	  for (kind = 0; kind < GC_n_kinds; kind++) {
	    for (size = 1; size <= MAXOBJSZ; size++) {
	      for (p= GC_obj_kinds[kind].ok_freelist[size];
	           p != 0; p=obj_link(p)){
		h = HBLKPTR(p);
		hhdr = HDR(h);
		word_no = (((word *)p) - ((word *)h));
		set_mark_bit_from_hdr(hhdr, word_no);
	      }
	    }
	  }
	}
      /* Check that everything is marked */
	GC_start_reclaim(TRUE);
#   else /* FIND_LEAK */

      GC_finalize();
#     ifdef STUBBORN_ALLOC
        GC_clean_changing_list();
#     endif

#     ifdef PRINTTIMES
	GET_TIME(finalize_time);
#     endif

      /* Clear free list mark bits, in case they got accidentally marked   */
      /* Note: HBLKPTR(p) == pointer to head of block containing *p        */
      /* Also subtract memory remaining from GC_mem_found count.           */
      /* Note that composite objects on free list are cleared.             */
      /* Thus accidentally marking a free list is not a problem;  only     */
      /* objects on the list itself will be marked, and that's fixed here. */
#ifdef SHAREDGC /* Added by Endo */

#if DO_SRECLAIM == 4 /* for Parallel reclaim */
    GC_sh_reclaim_main();
    GC_arrays_p->debug_gcing = 0;
    GC_sh_start_world();

#else
#if DO_CLEAR_FLOBJ == 1
      {
	register word size;		/* current object size		*/
	register ptr_t p;	/* pointer to current object	*/
	register struct hblk * h;	/* pointer to block containing *p */
	register hdr * hhdr;
	register int word_no;           /* "index" of *p in *q          */
	int kind;

	int procno;
	ptr_t fl;
 
	for (procno = 0; procno < SH_MAX_USERPROCESS; procno++) {
	if (GC_sh_lenv_p(procno) == NULL) continue;

	for (kind = 0; kind < GC_n_kinds; kind++) {
	  for (size = 1; size <= MAXOBJSZ; size++) {
	    fl = GC_sh_lenv_p(procno)->_freelist[kind][size];
	    for (p= fl; p != 0; p=obj_link(p)){
		h = HBLKPTR(p);
		hhdr = HDR(h);
		word_no = (((word *)p) - ((word *)h));
		clear_mark_bit_from_hdr(hhdr, word_no);
#		ifdef GATHERSTATS
		    GC_sum_gc_stat.mem_found -= size;
#		endif
	    }
	    fl = NULL;
	  }
	}
        }
      }
#endif

#     ifdef PRINTSTATS
	GC_printf1("Bytes recovered before sweep - f.l. count = %ld\n",
	          (long)WORDS_TO_BYTES(GC_sum_gc_stat.mem_found));
#     endif

    /* Reconstruct free lists to contain everything not marked */
      GC_start_reclaim(FALSE);
    GC_arrays_p->debug_gcing = 0;
    GC_sh_start_world();

#endif /* DO_SRECLAIM */

#else /* SHAREDGC */
  GC_gcrlog_init_sweep();
      {
	register word size;		/* current object size		*/
	register ptr_t p;	/* pointer to current object	*/
	register struct hblk * h;	/* pointer to block containing *p */
	register hdr * hhdr;
	register int word_no;           /* "index" of *p in *q          */
	int kind;

	for (kind = 0; kind < GC_n_kinds; kind++) {
	  for (size = 1; size <= MAXOBJSZ; size++) {
	    for (p= GC_obj_kinds[kind].ok_freelist[size];
	         p != 0; p=obj_link(p)){
		h = HBLKPTR(p);
		hhdr = HDR(h);
		word_no = (((word *)p) - ((word *)h));
		clear_mark_bit_from_hdr(hhdr, word_no);
#		ifdef GATHERSTATS
		    GC_sum_gc_stat.mem_found -= size;
#		endif
	    }
	  }
	}
      }
#     ifdef PRINTSTATS
	GC_printf1("Bytes recovered before sweep - f.l. count = %ld\n",
	          (long)WORDS_TO_BYTES(GC_sum_gc_stat.mem_found));
#     endif

    /* Reconstruct free lists to contain everything not marked */
      GC_start_reclaim(FALSE);
  GC_gcrlog_end_sweep();

#endif /* SHAREDGC */

#   endif /* !FIND_LEAK */

#   ifdef PRINTSTATS
	GC_printf2(
		  "Immediately reclaimed %ld bytes in heap of size %lu bytes\n",
	          (long)WORDS_TO_BYTES(GC_sum_gc_stat.mem_found),
	          (unsigned long)GC_heapsize);
	GC_printf2("%lu (atomic) + %lu (composite) collectable bytes in use\n",
	           (unsigned long)WORDS_TO_BYTES(GC_atomic_in_use),
	           (unsigned long)WORDS_TO_BYTES(GC_composite_in_use));
#   endif

    /* Reset or increment counters for next cycle */
#ifdef SHAREDGC /* Added by Endo */
	{
	    int procno;
	    appproc_stat_t *l_statp;

	    for (procno = 0; procno < SGC_MAX_APP_PROCESS; procno++) {
		if (!IS_VALID_APPPNO(procno)) continue;
		l_statp = &GC_l_appenvp(procno)->stat;
		l_statp->words_allocd_before_gc +=
		    l_statp->words_allocd;
		l_statp->non_gc_bytes_at_gc =
		    l_statp->non_gc_bytes;
		l_statp->words_allocd = 0;
		l_statp->words_wasted = 0;
		l_statp->mem_freed = 0;
	    }
	}
	GC_sh_sumup_counters();
#else
      GC_sum_words_allocd_before_gc += GC_sum_words_allocd;
      GC_sum_non_gc_bytes_at_gc = GC_sum_non_gc_bytes;
      GC_sum_words_allocd = 0;
      GC_sum_words_wasted = 0;
      GC_sum_mem_freed = 0;
#endif
      
#   ifdef PRINTTIMES
	GET_TIME(done_time);
	GC_printf2("Finalize + initiate sweep took %lu + %lu msecs\n",
	           MS_TIME_DIFF(finalize_time,start_time),
	           MS_TIME_DIFF(done_time,finalize_time));
#   endif

}

/* Externally callable routine to invoke full, stop-world collection */
# if defined(__STDC__) || defined(__cplusplus)
    int GC_try_to_collect(GC_stop_func stop_func)
# else
    int GC_try_to_collect(stop_func)
    GC_stop_func stop_func;
# endif
{
    int result;
    DCL_LOCK_STATE;
    
    GC_invoke_finalizers();
    DISABLE_SIGNALS();
    LOCK();
    if (!GC_is_initialized) GC_init_inner();
    /* Minimize junk left in my registers */
      GC_noop(0,0,0,0,0,0);
    result = (int)GC_try_to_collect_inner(stop_func);
    UNLOCK();
    ENABLE_SIGNALS();
    if(result) GC_invoke_finalizers();
    return(result);
}

void GC_gcollect GC_PROTO(())
{
    (void)GC_try_to_collect(GC_never_stop_func);
}



/************************************************ from reclaim.c */
/*
 * Do the same thing on the entire heap, after first clearing small object
 * free lists (if we are not just looking for leaks).
 */
void GC_start_reclaim(abort_if_found)
int abort_if_found;		/* Abort if a GC_reclaimable object is found */
{
    int kind;
    
#ifdef SHAREDGC /* Added by Endo */
    int procno;

    for (procno = 0; procno < SH_MAX_USERPROCESS; procno++) {
	if (GC_sh_lenv_p(procno) == NULL) continue;

      /* Clear reclaim- and free-lists */
      for (kind = 0; kind < GC_n_kinds; kind++) {
        register ptr_t *fop;
        register ptr_t *lim;
        register struct hblk ** rlp;
        register struct hblk ** rlim;
        register struct hblk ** rlist = GC_sh_lenv_p(procno)->_reclaim_lists[kind];
        
        if (rlist == 0) continue;	/* This kind not used.	*/
        if (!abort_if_found) {
            lim = &(GC_sh_lenv_p(procno)->_freelist[kind][MAXOBJSZ+1]);
	    for( fop = GC_sh_lenv_p(procno)->_freelist[kind]; fop < lim; fop++ ) {
	      *fop = 0;
	    }
	} /* otherwise free list objects are marked, 	*/
	  /* and its safe to leave them			*/
	rlim = rlist + MAXOBJSZ+1;
	for( rlp = rlist; rlp < rlim; rlp++ ) {
	    *rlp = 0;
	}
      }
    }
#else
    /* Clear reclaim- and free-lists */
      for (kind = 0; kind < GC_n_kinds; kind++) {
        register ptr_t *fop;
        register ptr_t *lim;
        register struct hblk ** rlp;
        register struct hblk ** rlim;
        register struct hblk ** rlist = GC_obj_kinds[kind].ok_reclaim_list;
        
        if (rlist == 0) continue;	/* This kind not used.	*/
        if (!abort_if_found) {
            lim = &(GC_obj_kinds[kind].ok_freelist[MAXOBJSZ+1]);
	    for( fop = GC_obj_kinds[kind].ok_freelist; fop < lim; fop++ ) {
	      *fop = 0;
	    }
	} /* otherwise free list objects are marked, 	*/
	  /* and its safe to leave them			*/
	rlim = rlist + MAXOBJSZ+1;
	for( rlp = rlist; rlp < rlim; rlp++ ) {
	    *rlp = 0;
	}
      }
#endif
    
#   ifdef PRINTBLOCKS
        GC_printf0("GC_reclaim: current block sizes:\n");
        GC_print_block_list();
#   endif

    GC_MARKLOG_START_CLOCK();

  /* Go through all heap blocks (in hblklist) and reclaim unmarked objects */
  /* or enqueue the block for later processing.				   */
    GC_apply_to_all_blocks(GC_reclaim_block, (word)abort_if_found);
    
    GC_MARKLOG_STOP_CLOCK();
#if 0
    GC_sh_doall(GC_sh_after_marksweep_local, NULL, NULL, NULL);
#endif
    GC_MARKLOG_END_PHASE();
}

/*
 * Reclaim all small blocks waiting to be reclaimed.
 * Abort and return FALSE when/if (*stop_func)() returns TRUE.
 * If this returns TRUE, then it's safe to restart the world
 * with incorrectly cleared mark bits.
 */
bool GC_reclaim_all(stop_func)
GC_stop_func stop_func;
{
    SH_USE_MYENV;
    register word sz;
    register int kind;
    register hdr * hhdr;
    register struct hblk * hbp;
    register struct obj_kind * ok;
    struct hblk ** rlp;
    struct hblk ** rlh;
#   ifdef PRINTTIMES
	CLOCK_TYPE start_time;
	CLOCK_TYPE done_time;
	
	GET_TIME(start_time);
#   endif
    
    for (kind = 0; kind < GC_n_kinds; kind++) {
    	rlp = GC_reclaim_list[kind];
    	if (rlp == 0) continue;
    	for (sz = 1; sz <= MAXOBJSZ; sz++) {
    	    rlh = rlp + sz;
    	    while ((hbp = *rlh) != 0) {
    	        if ((*stop_func)()) return(FALSE);
        	hhdr = HDR(hbp);
        	*rlh = hhdr -> hb_next;
        	GC_reclaim_small_nonempty_block(hbp, FALSE);
            }
        }
    }
#   ifdef PRINTTIMES
	GET_TIME(done_time);
	GC_printf1("Disposing of reclaim lists took %lu msecs\n",
	           MS_TIME_DIFF(done_time,start_time));
#   endif
    return(TRUE);
}


/************************************************ from mark.c */
/* Added by Endo */
/* priv_mark_stack contains objects that can be touched only owner */
/* (such as root objects). */
void GC_mark_from_priv_mark_stack()
{
    SH_USE_MYENV;
  mse * priv_mark_stack_reg = GC_priv_mark_stack.bottom;
  mse * priv_mark_stack_top_reg = GC_priv_mark_stack.top;
  mse * priv_mark_stack_limit = &(GC_priv_mark_stack.buf[GC_priv_mark_stack.size]);
  mse * mark_stack_reg = GC_mark_stack.bottom;
  mse * mark_stack_top_reg = GC_mark_stack.top;
  mse * mark_stack_limit = &(GC_mark_stack.buf[GC_mark_stack.size]);
  int credit = PRIV_INITIAL_CREDIT;/* Remaining credit for marking work	*/
  register word * current_p;	/* Pointer to current candidate ptr.	*/
  register word current;	/* Candidate pointer.			*/
  register word * limit;	/* (Incl) limit of current candidate 	*/
  				/* range				*/
  register word descr;
  register ptr_t greatest_ha = GC_greatest_plausible_heap_addr;
  register ptr_t least_ha = GC_least_plausible_heap_addr;
  word n_marked; /* Added by Endo for measurement */
  word n_hasmarked; /* Added by Endo for measurement */
  word words_scaned; /* Added by Endo for measurement */
  word n_pushed; /* Added by Endo for measurement */

  GC_objects_are_marked = TRUE;

#ifdef DO_MARKLOG_AX
    n_marked = 0;
#endif

    GC_LDLOG_PUT(GC_LDC_S, GC_LDK_SROOT);

  while (priv_mark_stack_top_reg >= priv_mark_stack_reg && credit > 0) {

    current_p = priv_mark_stack_top_reg -> mse_start;
    descr = priv_mark_stack_top_reg -> mse_descr;
  retry:  
    if (descr & ((~(WORDS_TO_BYTES(SPLIT_RANGE_WORDS) - 1)) | DS_TAGS)) {
	word tag = descr & DS_TAGS;
	if (tag != DS_LENGTH) {
	    fprintf(stderr, "GC_mark_from_priv_mark_stack: Bad tag for root");
	    exit(1);
	}
	/* tag is DS_LENGTH only. */
          /* Large length.					        */
          /* Process part of the range to avoid pushing too much on the	*/
          /* stack.							*/
	  priv_mark_stack_top_reg -> mse_start =
         	limit = current_p + SPLIT_RANGE_WORDS-1;
          priv_mark_stack_top_reg -> mse_descr -=
          		WORDS_TO_BYTES(SPLIT_RANGE_WORDS-1);
          /* Make sure that pointers overlapping the two ranges are	*/
          /* considered. 						*/
          limit = (word *)((char *)limit + sizeof(word) - ALIGNMENT);
    } else {
      priv_mark_stack_top_reg--;
      limit = (word *)(((ptr_t)current_p) + (word)descr);
    }

#ifdef DO_MARKLOG_AX
    n_marked = 0;
    n_hasmarked = 0;
    words_scaned = ((char *)limit - (char *)current_p) / ALIGNMENT + 1;
    n_pushed = 0;
#endif

    /* The simple case in which we're scanning a range.	*/
    credit -= (ptr_t)limit - (ptr_t)current_p;
    limit -= 1;

    while (current_p <= limit) {
      current = *current_p;
      current_p = (word *)((char *)current_p + ALIGNMENT);
      if ((ptr_t)current < least_ha) continue;
      if ((ptr_t)current >= greatest_ha) continue;
      PUSH_CONTENTS(current, mark_stack_top_reg, mark_stack_limit);
    }
    GC_FAST_MARKLOG_PUT(GC_LOGKIND_N_MARKED, n_marked);
    GC_FAST_MARKLOG_PUT(GC_LOGKIND_N_HASMARKED, n_hasmarked);
    GC_FAST_MARKLOG_PUT(GC_LOGKIND_N_NONPTR, words_scaned - n_marked - n_hasmarked);
  }
  GC_priv_mark_stack.top = priv_mark_stack_top_reg;
  GC_mark_stack.top = mark_stack_top_reg;

  GC_LDLOG_PUT(GC_LDC_E, GC_LDK_SROOT);
}

/* Added by Endo */
/* Same as GC_push_all, but this pushes onto private stack. */
void GC_push_all_priv(bottom, top)
ptr_t bottom;
ptr_t top;
{
    SH_USE_MYENV;
    register word length;

    bottom = (ptr_t)(((word) bottom + ALIGNMENT-1) & ~(ALIGNMENT-1));
    top = (ptr_t)(((word) top) & ~(ALIGNMENT-1));
    if (top == 0 || bottom == top) return;
    GC_priv_mark_stack.top++;
    if (GC_priv_mark_stack.top >= GC_priv_mark_stack.buf + GC_priv_mark_stack.size) {
	ABORT("unexpected mark stack overflow (GC_push_all_priv)");
    }
    length = top - bottom;
#   if DS_TAGS > ALIGNMENT - 1
	length += DS_TAGS;
	length &= ~DS_TAGS;
#   endif
    GC_priv_mark_stack.top -> mse_start = (word *)bottom;
    GC_priv_mark_stack.top -> mse_descr = length;
#if 0
fprintf(stderr, "[GC_push_all_priv] Push onto pms %08x(len %08x)\n",
	bottom, length);
#endif
}

void GC_mark_init()
{
    alloc_mark_stack(INITIAL_MARK_STACK_SIZE);
}

/* Allocate or reallocate space for mark stack of size s words  */
/* May silently fail.						*/
static void alloc_mark_stack(n)
word n;
{
    SH_USE_MYENV;
#ifdef SHAREDGC
    GC_mark_stack_expand(n);
    exit(1);
#else
    mse * new_stack = (mse *)GC_scratch_alloc(n * sizeof(struct ms_entry));
    
    GC_mark_stack_too_small = FALSE;
    if (GC_mark_stack_size != 0) {
        if (new_stack != 0) {
          word displ = HBLKDISPL(GC_mark_stack);
          word size = GC_mark_stack_size * sizeof(struct ms_entry);
          
          /* Recycle old space */
            if (displ == 0) {
              GC_add_to_heap((struct hblk *)GC_mark_stack, size);
	    } else {
	      GC_add_to_heap((struct hblk *)
	      			((word)GC_mark_stack - displ + HBLKSIZE),
	      		     size - HBLKSIZE);
	    }
          GC_mark_stack = new_stack;
          GC_mark_stack_size = n;
#	  ifdef PRINTSTATS
	      GC_printf1("Grew mark stack to %lu frames\n",
		    	 (unsigned long) GC_mark_stack_size);
#	  endif
        } else {
#	  ifdef PRINTSTATS
	      GC_printf1("Failed to grow mark stack to %lu frames\n",
		    	 (unsigned long) n);
#	  endif
        }
    } else {
        if (new_stack == 0) {
            GC_err_printf0("No space for mark stack\n");
            EXIT();
        }
        GC_mark_stack = new_stack;
        GC_mark_stack_size = n;
    }
    GC_mark_stack_top = GC_mark_stack-1;
#endif
}

/* Initiate full marking.	*/
void GC_initiate_full()
{
#   ifdef PRINTSTATS
	GC_printf2("***>Full mark for collection %lu after %ld allocd bytes\n",
		  (unsigned long) GC_gc_no+1,
	   	  (long)WORDS_TO_BYTES(GC_sum_app_stat.words_allocd));
#   endif
    GC_promote_black_lists();
    GC_reclaim_or_delete_all();
    GC_clear_marks();
    GC_read_dirty();
#   ifdef STUBBORN_ALLOC
    	GC_read_changed();
#   endif
#   ifdef CHECKSUMS
	{
	    extern void GC_check_dirty();
	    
	    GC_check_dirty();
	}
#   endif
#   ifdef GATHERSTATS
	GC_n_rescuing_pages = 0;
#   endif
}

/* Initiate partial marking.	*/
/*ARGSUSED*/
void GC_initiate_partial()
{
    if (GC_dirty_maintained) GC_read_dirty();
#   ifdef STUBBORN_ALLOC
    	GC_read_changed();
#   endif
#   ifdef CHECKSUMS
	{
	    extern void GC_check_dirty();
	    
	    if (GC_dirty_maintained) GC_check_dirty();
	}
#   endif
#   ifdef GATHERSTATS
	GC_n_rescuing_pages = 0;
#   endif
    if (GC_myg_mark_state == MS_NONE) {
        GC_myg_mark_state = MS_PUSH_RESCUERS;
    } else if (GC_myg_mark_state != MS_INVALID) {
    	ABORT("unexpected state");
    } /* else this is really a full collection, and mark	*/
      /* bits are invalid.					*/
    GC_scan_ptr = 0;
}

/************************************************ from malloc.c */
/* Allocate reclaim list for kind:	*/
/* Return TRUE on success		*/
bool GC_alloc_reclaim_list(kind)
register struct obj_kind * kind;
{
    struct hblk ** result = (struct hblk **)
    		GC_scratch_alloc((MAXOBJSZ+1) * sizeof(struct hblk *));
    if (result == 0) return(FALSE);
    BZERO(result, (MAXOBJSZ+1)*sizeof(struct hblk *));
    kind -> ok_reclaim_list = result;
    return(TRUE);
}


/************************************************ from misc.c */
void GC_init()
{
    DCL_LOCK_STATE;
    
#ifdef SHAREDGC
    /* GC_sh_init_leader(); */
#endif
    DISABLE_SIGNALS();
    LOCK();
    GC_init_inner();
    UNLOCK();
    ENABLE_SIGNALS();

}

#ifdef MSWIN32
    extern void GC_init_win32();
#endif

/* Name changed by Endo */
void GC_init_inner_inner()
{
    SH_USE_MYENV;
    word dummy;
    
    if (GC_is_initialized) return;

    SH_LOCK();

    /* Added by Endo */
    GC_all_bottom_indices = 0;
    GC_hblkfreelist = 0;
    GC_savhbp = (struct hblk *)0;
    GC_freehblk_ptr = 0;
    GC_n_heap_sects = 0;
    GC_least_plausible_heap_addr = (ptr_t)ONES;
    GC_greatest_plausible_heap_addr = 0;

#   ifdef MSWIN32
 	GC_init_win32();
#   endif
#   ifdef SOLARIS_THREADS
	/* We need dirty bits in order to find live stack sections.	*/
        GC_dirty_init();
#   endif
#   if !defined(THREADS) || defined(SOLARIS_THREADS) || defined(SHAREDGC) 
      if (GC_stackbottom == 0) {
	GC_stackbottom = GC_get_stack_base();
      }
#   endif
    if  (sizeof (ptr_t) != sizeof(word)) {
        ABORT("sizeof (ptr_t) != sizeof(word)\n");
    }
    if  (sizeof (signed_word) != sizeof(word)) {
        ABORT("sizeof (signed_word) != sizeof(word)\n");
    }
    if  (sizeof (struct hblk) != HBLKSIZE) {
        ABORT("sizeof (struct hblk) != HBLKSIZE\n");
    }
#   ifndef THREADS
#     if defined(STACK_GROWS_UP) && defined(STACK_GROWS_DOWN)
  	ABORT(
  	  "Only one of STACK_GROWS_UP and STACK_GROWS_DOWN should be defd\n");
#     endif
#     if !defined(STACK_GROWS_UP) && !defined(STACK_GROWS_DOWN)
  	ABORT(
  	  "One of STACK_GROWS_UP and STACK_GROWS_DOWN should be defd\n");
#     endif
#     ifdef STACK_GROWS_DOWN
        if ((word)(&dummy) > (word)GC_stackbottom) {
          GC_err_printf0(
          	"STACK_GROWS_DOWN is defd, but stack appears to grow up\n");
          GC_err_printf2("sp = 0x%lx, GC_stackbottom = 0x%lx\n",
          	   	 (unsigned long) (&dummy),
          	   	 (unsigned long) GC_stackbottom);
          ABORT("stack direction 3\n");
        }
#     else
        if ((word)(&dummy) < (word)GC_stackbottom) {
          GC_err_printf0(
          	"STACK_GROWS_UP is defd, but stack appears to grow down\n");
          GC_err_printf2("sp = 0x%lx, GC_stackbottom = 0x%lx\n",
          	       	 (unsigned long) (&dummy),
          	     	 (unsigned long) GC_stackbottom);
          ABORT("stack direction 4");
        }
#     endif
#   endif
#   if !defined(_AUX_SOURCE) || defined(__GNUC__)
      if ((word)(-1) < (word)0) {
    	GC_err_printf0("The type word should be an unsigned integer type\n");
    	GC_err_printf0("It appears to be signed\n");
    	ABORT("word");
      }
#   endif
    if ((signed_word)(-1) >= (signed_word)0) {
    	GC_err_printf0(
    		"The type signed_word should be a signed integer type\n");
    	GC_err_printf0("It appears to be unsigned\n");
    	ABORT("signed_word");
    }
    
    /* Add initial guess of root sets.  Do this first, since sbrk(0)	*/
    /* mightbe used.							*/
      GC_register_data_segments();
    GC_init_headers();
        GC_bl_init();
# ifdef SHAREDGC
# else
    GC_mark_init();
# endif
    if (!GC_expand_hp_inner((word)MINHINCR)) {
        GC_err_printf0("Can't start up: not enough memory\n");
        EXIT();
    }
    /* Preallocate large object map.  It's otherwise inconvenient to 	*/
    /* deal with failure.						*/
      if (!GC_add_map_entry((word)0)) {
        GC_err_printf0("Can't start up: not enough memory\n");
        EXIT();
      }
    GC_register_displacement_inner(0L);
#   ifdef MERGE_SIZES
      GC_init_size_map();
#   endif
#   ifdef PCR
      if (PCR_IL_Lock(PCR_Bool_false, PCR_allSigsBlocked, PCR_waitForever)
          != PCR_ERes_okay) {
          ABORT("Can't lock load state\n");
      } else if (PCR_IL_Unlock() != PCR_ERes_okay) {
          ABORT("Can't unlock load state\n");
      }
      PCR_IL_Unlock();
      GC_pcr_install();
#   endif
    /* Get black list set up */
      GC_gcollect_inner();
#   ifdef STUBBORN_ALLOC
    	GC_stubborn_init();
#   endif
    GC_is_initialized = TRUE;
    /* Convince lint that some things are used */
#   ifdef LINT
      {
          extern char * GC_copyright[];
          extern int GC_read();
          extern void GC_register_finalizer_no_order();
          
          GC_noop(GC_copyright, GC_find_header,
                  GC_push_one, GC_call_with_alloc_lock, GC_read,
                  GC_dont_expand,
#		  ifndef NO_DEBUGGING
		    GC_dump,
#		  endif
                  GC_register_finalizer_no_order);
      }
#   endif

    SH_UNLOCK();
    return;
}

void GC_init_inner()
{
    if (GC_is_initialized) return;
    GC_init_inner_inner();
    GC_is_initialized = TRUE;
    return;
}

void GC_enable_incremental GC_PROTO(())
{
    SH_USE_MYENV;

#if 0    
    DCL_LOCK_STATE;

# ifndef FIND_LEAK
    DISABLE_SIGNALS();
    LOCK();
    if (GC_incremental) goto out;
#   ifdef MSWIN32
      {
        extern bool GC_is_win32s();

	/* VirtualProtect is not functional under win32s.	*/
	if (GC_is_win32s()) goto out;
      }
#   endif /* MSWIN32 */
#   ifndef SOLARIS_THREADS
        GC_dirty_init();
#   endif
#if 0
    if (!GC_is_initialized) {
        GC_init_inner();
    }
#endif
    if (GC_dont_gc) {
        /* Can't easily do it. */
        UNLOCK();
    	ENABLE_SIGNALS();
    	return;
    }
    if (GC_sum_app_stat.words_allocd > 0) {
    	/* There may be unmarked reachable objects	*/
    	GC_sh_gcollect_inner();
    }   /* else we're OK in assuming everything's	*/
    	/* clean since nothing can point to an	  	*/
    	/* unmarked object.			  	*/
    GC_read_dirty();
    GC_incremental = TRUE;
out:
    UNLOCK();
    ENABLE_SIGNALS();
# endif /* FIND_LEAK */

#endif /* 0 */
}

/************************************************ from gc.h */
#ifdef SOLARIS_THREADS
/* We need to intercept calls to many of the threads primitives, so 	*/
/* that we can locate thread stacks and stop the world.			*/
/* Note also that the collector cannot see thread specific data.	*/
/* Thread specific data should generally consist of pointers to		*/
/* uncollectable objects, which are deallocated using the destructor	*/
/* facility in thr_keycreate.						*/
# include <thread.h>
# include <signal.h>
  int GC_thr_create(void *stack_base, size_t stack_size,
                    void *(*start_routine)(void *), void *arg, long flags,
                    thread_t *new_thread);
  int GC_thr_join(thread_t wait_for, thread_t *departed, void **status);
  int GC_thr_suspend(thread_t target_thread);
  int GC_thr_continue(thread_t target_thread);
  void * GC_dlopen(const char *path, int mode);

# define thr_create GC_thr_create
# define thr_join GC_thr_join
# define thr_suspend GC_thr_suspend
# define thr_continue GC_thr_continue
# define dlopen GC_dlopen

/* This returns a list of objects, linked through their first		*/
/* word.  Its use can greatly reduce lock contention problems, since	*/
/* the allocation lock can be acquired and released many fewer times.	*/
GC_PTR GC_malloc_many(size_t lb);
#define GC_NEXT(p) (*(GC_PTR *)(p)) 	/* Retrieve the next element	*/
					/* in returned list.		*/

#endif /* SOLARIS_THREADS */

/**************************************************** from gc_priv.h */
/*
 * Mutual exclusion between allocator/collector routines.
 * Needed if there is more than one allocator thread.
 * FASTLOCK() is assumed to try to acquire the lock in a cheap and
 * dirty way that is acceptable for a few instructions, e.g. by
 * inhibiting preemption.  This is assumed to have succeeded only
 * if a subsequent call to FASTLOCK_SUCCEEDED() returns TRUE.
 * FASTUNLOCK() is called whether or not FASTLOCK_SUCCEEDED().
 * If signals cannot be tolerated with the FASTLOCK held, then
 * FASTLOCK should disable signals.  The code executed under
 * FASTLOCK is otherwise immune to interruption, provided it is
 * not restarted.
 * DCL_LOCK_STATE declares any local variables needed by LOCK and UNLOCK
 * and/or DISABLE_SIGNALS and ENABLE_SIGNALS and/or FASTLOCK.
 * (There is currently no equivalent for FASTLOCK.)
 */  
# ifdef THREADS
#  ifdef SOLARIS_THREADS
#    include <thread.h>
#    include <signal.h>
     extern mutex_t GC_allocate_ml;
#    define LOCK() mutex_lock(&GC_allocate_ml);
#    define UNLOCK() mutex_unlock(&GC_allocate_ml);
#  endif

/**************************************************** from mark_rts.h */

/*
 * Call the mark routines (GC_tl_push for a single pointer, GC_push_conditional
 * on groups of pointers) on every top level accessible pointer.
 * If all is FALSE, arrange to push only possibly altered values.
 */

void GC_push_roots(all)
bool all;
{
    register int i;

    /*
     * push registers - i.e., call GC_push_one(r) for each
     * register contents r.
     */
        GC_push_regs(); /* usually defined in machine_dep.c */
        
    /*
     * Next push static data.  This must happen early on, since it's
     * not robust against mark stack overflow.
     */
     /* Reregister dynamic libraries, in case one got added.	*/
#      if (defined(DYNAMIC_LOADING) || defined(MSWIN32) || defined(PCR)) \
           && !defined(SRC_M3)
         GC_remove_tmp_roots();
        GC_register_dynamic_libraries();
#      endif

     /* Mark everything in static data areas                             */
       for (i = 0; i < n_root_sets; i++) {
         GC_push_conditional(static_roots[i].r_start,
			     static_roots[i].r_end, all);
       }

    /*
     * Now traverse stacks.
     */
#   ifndef THREADS
        /* Mark everything on the stack.           */
#   	  ifdef STACK_GROWS_DOWN
	    GC_push_all_stack( GC_approx_sp(), GC_stackbottom );
#	  else
	    GC_push_all_stack( GC_stackbottom, GC_approx_sp() );
#	  endif
#   endif
    if (GC_push_other_roots != 0) (*GC_push_other_roots)();
    	/* In the threads case, this also pushes thread stacks.	*/
}


/****************************************************** from blacklst.c */
void GC_add_to_black_list_normal(p)
word p;
{
    if (!(GC_modws_valid_offsets[p & (sizeof(word)-1)])) return;
    {
        register int index = PHT_HASH(p);
       
        if (HDR(p) == 0 || get_pht_entry_from_index(GC_old_normal_bl, index)) {
#   	    ifdef PRINTBLACKLIST
		if (!get_pht_entry_from_index(GC_incomplete_normal_bl, index)) {
	    	  GC_printf1("Black listing (normal) 0x%lx\n",
	    	  	     (unsigned long) p);
	    	}
#           endif
	    PSM_mutex_lock(&GC_black_list_ml);
            set_pht_entry_from_index(GC_incomplete_normal_bl, index);
	    PSM_mutex_unlock(&GC_black_list_ml);
        } /* else this is probably just an interior pointer to an allocated */
          /* object, and isn't worth black listing.			    */
    }
}
