# config.mk must be included before this file.

#C_OPT_FLAGS=-O2
C_OPT_FLAGS=
C_DEBUG_FLAGS=-g #-xpg  #-pg # for profiling

ifeq ($(SGC_CPU_TYPE),sparc)
ifeq ($(CC),gcc)
	C_REGVAR_FLAGS = -ffixed-%l7 -mflat
	C_PSM_FLAGS = -Wa,-xarch=v8plusa
else
	C_OPT_FLAGS=-xO2
	C_REGVAR_FLAGS = 
	C_PSM_FLAGS = -xarch=v8plusa
endif
	ASM_PSM_FLAGS = -xarch=v8plusa
endif
ifeq ($(SGC_CPU_TYPE),mips)
ifeq ($(CC),gcc)
	C_REGVAR_FLAGS = -ffixed-%23
ifeq ($(OBJECT_64BIT),YES)
	C_PSM_FLAGS = -mabi=64
	ASM_PSM_FLAGS = -mips4 -64
else
	C_PSM_FLAGS = -mips2
	ASM_PSM_FLAGS = -mips2
endif
else
	C_DEBUG_FLAGS=-g3
ifeq ($(OBJECT_64BIT),YES)
	C_REGVAR_FLAGS =
	C_PSM_FLAGS = -mips4 -64
	ASM_PSM_FLAGS = -mips4 -64
else
	C_REGVAR_FLAGS =
	C_PSM_FLAGS = -mips2
	ASM_PSM_FLAGS = -mips2
endif
endif
endif
ifeq ($(SGC_CPU_TYPE),i386)
ifeq ($(CC),gcc)
	C_REGVAR_FLAGS = -ffixed-%ebx
	C_PSM_FLAGS = -m486
else
# not tested yet...
	C_OPT_FLAGS=-xO2
	C_REGVAR_FLAGS =
	C_PSM_FLAGS = -xarch=386
endif
	ASM_PSM_FLAGS = 
endif
ifeq ($(SGC_CPU_TYPE),hppa)
ifeq ($(CC),gcc)
	C_REGVAR_FLAGS =
	C_PSM_FLAGS =
	ASM_PSM_FLAGS = 
else
	C_OPT_FLAGS=
	C_REGVAR_FLAGS =
ifeq ($(OBJECT_64BIT),YES)
	C_PSM_FLAGS = +DA2.0W
	ASM_PSM_FLAGS = +DA2.0W
else
	C_PSM_FLAGS = +DA1.0
	ASM_PSM_FLAGS = +DA1.0
endif
endif
endif

C_WARNING_FLAGS =
#-Wall -Wstrict-prototypes -Wmissing-prototypes -Wmissing-declarations \
#-Wshadow

# both gc library and user program should use this flag.
C_SGC_COMMON_FLAGS = 
ifeq ($(SGC_TLS_METHOD),SGC_TLS_REGISTER_VARIABLE)
	C_SGC_COMMON_FLAGS := $(C_REGVAR_FLAGS) 
endif
ifeq ($(SGC_TLS_METHOD),SGC_TLS_STHREADS_MODE)
	C_SGC_COMMON_FLAGS := $(C_REGVAR_FLAGS) 
endif

ifeq ($(SGC_PSM_STANDALONE),NO)
	C_PSM_FLAGS := $(C_PSM_FLAGS) -DPSM_NOT_STANDALONE
endif

LD_SGC_COMMON_FLAGS =
